// D import file generated from 'derelict/sdl2/mixer.d'
module derelict.sdl2.mixer;
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.sdl2.types;
	import derelict.sdl2.functions;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "SDL2_mixer.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "/usr/local/lib/libSDL2_mixer.dylib, ../Frameworks/SDL2_mixer.framework/SDL2_mixer, /Library/Frameworks/SDL2_mixer.framework/SDL2_mixer, /System/Library/Frameworks/SDL2_mixer.framework/SDL2_mixer";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libSDL2_mixer.so, libSDL2_mixer-2.0.so, libSDL2_mixer-2.0.so.0, /usr/local/lib/libSDL2_mixer-2.0.so, /usr/local/lib/libSDL2_mixer-2.0.so.0";
			}
			else
			{
				static assert(0, "Need to implement SDL2_mixer libNames for this operating system.");
			}
		}
	}
}
enum : Uint8
{
	SDL_MIXER_MAJOR_VERSION = 2,
	SDL_MIXER_MINOR_VERSION = 0,
	SDL_MIXER_PATCHLEVEL = 0,
}
alias MIX_MAJOR_VERSION = SDL_MIXER_MAJOR_VERSION;
alias MIX_MINOR_VERSION = SDL_MIXER_MINOR_VERSION;
alias MIX_PATCH_LEVEL = SDL_MIXER_PATCHLEVEL;
nothrow @nogc void SDL_MIXER_VERSION(SDL_version* X);
alias SDL_MIX_VERSION = SDL_MIXER_VERSION;
alias Mix_SetError = SDL_SetError;
alias Mix_GetError = SDL_GetError;
alias MIX_InitFlags = int;
enum : int
{
	MIX_INIT_FLAC = 1,
	MIX_INIT_MOD = 2,
	MIX_INIT_MODPLUG = 4,
	MIX_INIT_MP3 = 8,
	MIX_INIT_OGG = 16,
	MIX_INIT_FLUIDSYNTH = 32,
}
enum 
{
	MIX_CHANNELS = 8,
	MIX_DEFAULT_FREQUENCY = 22050,
	MIX_DEFAULT_CHANNELS = 2,
	MIX_MAX_VOLUME = 128,
	MIX_CHANNEL_POST = -2,
}
version (LittleEndian)
{
	enum MIX_DEFAULT_FORMAT = AUDIO_S16LSB;
}
else
{
	enum MIX_DEFAULT_FORMAT = AUDIO_S16MSB;
}
struct Mix_Chunk
{
	int allocated;
	Uint8* abuf;
	Uint32 alen;
	Uint8 volume;
}
alias Mix_Fading = int;
enum : int
{
	MIX_NO_FADING,
	MIX_FADING_OUT,
	MIX_FADING_IN,
}
alias Mix_MusicType = int;
enum : int
{
	MUS_NONE,
	MUS_CMD,
	MUS_WAV,
	MUS_MOD,
	MUS_MID,
	MUS_OGG,
	MUS_MP3,
	MUS_MP3_MAD,
	MUS_FLAC,
	MUS_MODPLUG,
}
struct Mix_Music;
string MIX_EFFECTSMAXSPEED = "MIX_EFFECTSMAXSPEED";
extern (C) nothrow 
{
	alias Mix_EffectFunc_t = void function(int chan, void* stream, int len, void* udata);
	alias Mix_EffectDone_t = void function(int chan, void* udata);
}
nothrow @nogc 
{
	Mix_Chunk* Mix_LoadWAV(const(char)* file);
	int Mix_PlayChannel(int channel, Mix_Chunk* chunk, int loops);
	int Mix_FadeInChannel(int channel, Mix_Chunk* chunk, int loops, int ms);
}
extern (C) nothrow @nogc 
{
	alias da_Mix_Linked_Version = const(SDL_version)* function();
	alias da_Mix_Init = int function(int);
	alias da_Mix_Quit = void function();
	alias da_Mix_OpenAudio = int function(int, Uint16, int, int);
	alias da_Mix_AllocateChannels = int function(int);
	alias da_Mix_QuerySpec = int function(int*, Uint16*, int*);
	alias da_Mix_LoadWAV_RW = Mix_Chunk* function(SDL_RWops*, int);
	alias da_Mix_LoadMUS = Mix_Music* function(const(char)*);
	alias da_Mix_LoadMUS_RW = Mix_Music* function(SDL_RWops*, int);
	alias da_Mix_LoadMUSType_RW = Mix_Music* function(SDL_RWops*, Mix_MusicType, int);
	alias da_Mix_QuickLoad_WAV = Mix_Chunk* function(Uint8*);
	alias da_Mix_QuickLoad_RAW = Mix_Chunk* function(Uint8*, Uint32);
	alias da_Mix_FreeChunk = void function(Mix_Chunk*);
	alias da_Mix_FreeMusic = void function(Mix_Music*);
	alias da_Mix_GetNumChunkDecoders = int function();
	alias da_Mix_GetChunkDecoder = const(char)* function(int);
	alias da_Mix_GetNumMusicDecoders = int function();
	alias da_Mix_GetMusicDecoder = const(char)* function(int);
	alias da_Mix_GetMusicType = Mix_MusicType function(const(Mix_Music)*);
	alias da_Mix_SetPostMix = void function(void function(void*, Uint8*, int), void*);
	alias da_Mix_HookMusic = void function(void function(void*, Uint8*, int), void*);
	alias da_Mix_HookMusicFinished = void function(void function());
	alias da_Mix_GetMusicHookData = void* function();
	alias da_Mix_ChannelFinished = void function(void function(int channel));
	alias da_Mix_RegisterEffect = int function(int, Mix_EffectFunc_t, Mix_EffectDone_t, void*);
	alias da_Mix_UnregisterEffect = int function(int, Mix_EffectFunc_t);
	alias da_Mix_UnregisterAllEffects = int function(int);
	alias da_Mix_SetPanning = int function(int, Uint8, Uint8);
	alias da_Mix_SetPosition = int function(int, Sint16, Uint8);
	alias da_Mix_SetDistance = int function(int, Uint8);
	alias da_Mix_SetReverseStereo = int function(int, int);
	alias da_Mix_ReserveChannels = int function(int);
	alias da_Mix_GroupChannel = int function(int, int);
	alias da_Mix_GroupChannels = int function(int, int, int);
	alias da_Mix_GroupAvailable = int function(int);
	alias da_Mix_GroupCount = int function(int);
	alias da_Mix_GroupOldest = int function(int);
	alias da_Mix_GroupNewer = int function(int);
	alias da_Mix_PlayChannelTimed = int function(int, Mix_Chunk*, int, int);
	alias da_Mix_PlayMusic = int function(Mix_Music*, int);
	alias da_Mix_FadeInMusic = int function(Mix_Music*, int, int);
	alias da_Mix_FadeInMusicPos = int function(Mix_Music*, int, int, double);
	alias da_Mix_FadeInChannelTimed = int function(int, Mix_Chunk*, int, int, int);
	alias da_Mix_Volume = int function(int, int);
	alias da_Mix_VolumeChunk = int function(Mix_Chunk*, int);
	alias da_Mix_VolumeMusic = int function(int);
	alias da_Mix_HaltChannel = int function(int);
	alias da_Mix_HaltGroup = int function(int);
	alias da_Mix_HaltMusic = int function();
	alias da_Mix_ExpireChannel = int function(int, int);
	alias da_Mix_FadeOutChannel = int function(int, int);
	alias da_Mix_FadeOutGroup = int function(int, int);
	alias da_Mix_FadeOutMusic = int function(int);
	alias da_Mix_FadingMusic = Mix_Fading function();
	alias da_Mix_FadingChannel = Mix_Fading function(int);
	alias da_Mix_Pause = void function(int);
	alias da_Mix_Resume = void function(int);
	alias da_Mix_Paused = int function(int);
	alias da_Mix_PauseMusic = void function();
	alias da_Mix_ResumeMusic = void function();
	alias da_Mix_RewindMusic = void function();
	alias da_Mix_PausedMusic = int function();
	alias da_Mix_SetMusicPosition = int function(double);
	alias da_Mix_Playing = int function(int);
	alias da_Mix_PlayingMusic = int function();
	alias da_Mix_SetMusicCMD = int function(in char*);
	alias da_Mix_SetSynchroValue = int function(int);
	alias da_Mix_GetSynchroValue = int function();
	alias da_Mix_GetChunk = Mix_Chunk* function(int);
	alias da_Mix_CloseAudio = void function();
}
__gshared 
{
	da_Mix_Linked_Version Mix_Linked_Version;
	da_Mix_Init Mix_Init;
	da_Mix_Quit Mix_Quit;
	da_Mix_OpenAudio Mix_OpenAudio;
	da_Mix_AllocateChannels Mix_AllocateChannels;
	da_Mix_QuerySpec Mix_QuerySpec;
	da_Mix_LoadWAV_RW Mix_LoadWAV_RW;
	da_Mix_LoadMUS Mix_LoadMUS;
	da_Mix_LoadMUS_RW Mix_LoadMUS_RW;
	da_Mix_LoadMUSType_RW Mix_LoadMUSType_RW;
	da_Mix_QuickLoad_WAV Mix_QuickLoad_WAV;
	da_Mix_QuickLoad_RAW Mix_QuickLoad_RAW;
	da_Mix_FreeChunk Mix_FreeChunk;
	da_Mix_FreeMusic Mix_FreeMusic;
	da_Mix_GetNumChunkDecoders Mix_GetNumChunkDecoders;
	da_Mix_GetChunkDecoder Mix_GetChunkDecoder;
	da_Mix_GetNumMusicDecoders Mix_GetNumMusicDecoders;
	da_Mix_GetMusicDecoder Mix_GetMusicDecoder;
	da_Mix_GetMusicType Mix_GetMusicType;
	da_Mix_SetPostMix Mix_SetPostMix;
	da_Mix_HookMusic Mix_HookMusic;
	da_Mix_HookMusicFinished Mix_HookMusicFinished;
	da_Mix_GetMusicHookData Mix_GetMusicHookData;
	da_Mix_ChannelFinished Mix_ChannelFinished;
	da_Mix_RegisterEffect Mix_RegisterEffect;
	da_Mix_UnregisterEffect Mix_UnregisterEffect;
	da_Mix_UnregisterAllEffects Mix_UnregisterAllEffects;
	da_Mix_SetPanning Mix_SetPanning;
	da_Mix_SetPosition Mix_SetPosition;
	da_Mix_SetDistance Mix_SetDistance;
	da_Mix_SetReverseStereo Mix_SetReverseStereo;
	da_Mix_ReserveChannels Mix_ReserveChannels;
	da_Mix_GroupChannel Mix_GroupChannel;
	da_Mix_GroupChannels Mix_GroupChannels;
	da_Mix_GroupAvailable Mix_GroupAvailable;
	da_Mix_GroupCount Mix_GroupCount;
	da_Mix_GroupOldest Mix_GroupOldest;
	da_Mix_GroupNewer Mix_GroupNewer;
	da_Mix_PlayChannelTimed Mix_PlayChannelTimed;
	da_Mix_PlayMusic Mix_PlayMusic;
	da_Mix_FadeInMusic Mix_FadeInMusic;
	da_Mix_FadeInMusicPos Mix_FadeInMusicPos;
	da_Mix_FadeInChannelTimed Mix_FadeInChannelTimed;
	da_Mix_Volume Mix_Volume;
	da_Mix_VolumeChunk Mix_VolumeChunk;
	da_Mix_VolumeMusic Mix_VolumeMusic;
	da_Mix_HaltChannel Mix_HaltChannel;
	da_Mix_HaltGroup Mix_HaltGroup;
	da_Mix_HaltMusic Mix_HaltMusic;
	da_Mix_ExpireChannel Mix_ExpireChannel;
	da_Mix_FadeOutChannel Mix_FadeOutChannel;
	da_Mix_FadeOutGroup Mix_FadeOutGroup;
	da_Mix_FadeOutMusic Mix_FadeOutMusic;
	da_Mix_FadingMusic Mix_FadingMusic;
	da_Mix_FadingChannel Mix_FadingChannel;
	da_Mix_Pause Mix_Pause;
	da_Mix_Resume Mix_Resume;
	da_Mix_Paused Mix_Paused;
	da_Mix_PauseMusic Mix_PauseMusic;
	da_Mix_ResumeMusic Mix_ResumeMusic;
	da_Mix_RewindMusic Mix_RewindMusic;
	da_Mix_PausedMusic Mix_PausedMusic;
	da_Mix_SetMusicPosition Mix_SetMusicPosition;
	da_Mix_Playing Mix_Playing;
	da_Mix_PlayingMusic Mix_PlayingMusic;
	da_Mix_SetMusicCMD Mix_SetMusicCMD;
	da_Mix_SetSynchroValue Mix_SetSynchroValue;
	da_Mix_GetSynchroValue Mix_GetSynchroValue;
	da_Mix_GetChunk Mix_GetChunk;
	da_Mix_CloseAudio Mix_CloseAudio;
}
class DerelictSDL2MixerLoader : SharedLibLoader
{
	public this();
	protected override void loadSymbols();
}
__gshared DerelictSDL2MixerLoader DerelictSDL2Mixer;
shared static this();
