// D import file generated from 'derelict/sdl2/sdl.d'
module derelict.sdl2.sdl;
public 
{
	import derelict.sdl2.types;
	import derelict.sdl2.functions;
}
private 
{
	import derelict.util.loader;
	import derelict.util.system;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "SDL2.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "/usr/local/lib/libSDL2.dylib, /usr/local/lib/libSDL2/libSDL2.dylib, ../Frameworks/SDL2.framework/SDL2, /Library/Frameworks/SDL2.framework/SDL2, /System/Library/Frameworks/SDL2.framework/SDL2";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libSDL2.so, libSDL2-2.0.so, libSDL2-2.0.so.0, /usr/local/lib/libSDL2.so, /usr/local/lib/libSDL2-2.0.so, /usr/local/lib/libSDL2-2.0.so.0";
			}
			else
			{
				static assert(0, "Need to implement SDL2 libNames for this operating system.");
			}
		}
	}
}
private extern (C) nothrow alias da_SDL_SetMainReady = void function();
class DerelictSDL2Loader : SharedLibLoader
{
	public this();
	protected override void loadSymbols();
}
__gshared DerelictSDL2Loader DerelictSDL2;
shared static this();
