// D import file generated from 'derelict/sdl2/ttf.d'
module derelict.sdl2.ttf;
private 
{
	import core.stdc.config;
	import derelict.util.loader;
	import derelict.util.system;
	import derelict.sdl2.types;
	import derelict.sdl2.functions;
	static if (Derelict_OS_Windows)
	{
		enum libNames = "SDL2_ttf.dll";
	}
	else
	{
		static if (Derelict_OS_Mac)
		{
			enum libNames = "/usr/local/lib/libSDL2_ttf.dylib, ../Frameworks/SDL2_ttf.framework/SDL2_ttf, /Library/Frameworks/SDL2_ttf.framework/SDL2_ttf, /System/Library/Frameworks/SDL2_ttf.framework/SDL2_ttf";
		}
		else
		{
			static if (Derelict_OS_Posix)
			{
				enum libNames = "libSDL2_ttf.so, libSDL2_ttf-2.0.so, libSDL2_ttf-2.0.so.0, /usr/local/lib/libSDL2_ttf-2.0.so, /usr/local/lib/libSDL2_ttf-2.0.so.0";
			}
			else
			{
				static assert(0, "Need to implement SDL2_ttf libNames for this operating system.");
			}
		}
	}
}
enum : Uint8
{
	SDL_TTF_MAJOR_VERSION = 2,
	SDL_TTF_MINOR_VERSION = 0,
	SDL_TTF_PATCHLEVEL = 12,
}
alias TTF_MAJOR_VERSION = SDL_TTF_MAJOR_VERSION;
alias TTF_MINOR_VERSION = SDL_TTF_MINOR_VERSION;
alias TTF_PATCHLEVEL = SDL_TTF_PATCHLEVEL;
enum 
{
	UNICODE_BOM_NATIVE = 65279,
	UNICODE_BOM_SWAPPED = 65534,
	TTF_STYLE_NORMAL = 0,
	TTF_STYLE_BOLD = 1,
	TTF_STYLE_ITALIC = 2,
	TTF_STYLE_UNDERLINE = 4,
	TTF_STYLE_STRIKETHROUGH = 8,
}
enum 
{
	TTF_HINTING_NORMAL = 0,
	TTF_HINTING_LIGHT = 1,
	TTF_HINTING_MONO = 2,
	TTF_HINTING_NONE = 3,
}
alias TTF_SetError = SDL_SetError;
alias TTF_GetError = SDL_GetError;
struct TTF_Font;
nothrow @nogc 
{
	void SDL_TTF_VERSION(SDL_version* X);
	void TTF_VERSION(SDL_version* X);
}
extern (C) nothrow @nogc 
{
	alias da_TTF_Linked_Version = SDL_version* function();
	alias da_TTF_ByteSwappedUNICODE = void function(int);
	alias da_TTF_Init = int function();
	alias da_TTF_OpenFont = TTF_Font* function(const(char)*, int);
	alias da_TTF_OpenFontIndex = TTF_Font* function(const(char)*, int, c_long);
	alias da_TTF_OpenFontRW = TTF_Font* function(SDL_RWops*, int, int);
	alias da_TTF_OpenFontIndexRW = TTF_Font* function(SDL_RWops*, int, int, c_long);
	alias da_TTF_GetFontStyle = int function(const(TTF_Font)*);
	alias da_TTF_SetFontStyle = void function(const(TTF_Font)*, int style);
	alias da_TTF_GetFontOutline = int function(const(TTF_Font)*);
	alias da_TTF_SetFontOutline = void function(TTF_Font*, int);
	alias da_TTF_GetFontHinting = int function(const(TTF_Font)*);
	alias da_TTF_SetFontHinting = void function(TTF_Font*, int);
	alias da_TTF_FontHeight = int function(const(TTF_Font)*);
	alias da_TTF_FontAscent = int function(const(TTF_Font)*);
	alias da_TTF_FontDescent = int function(const(TTF_Font)*);
	alias da_TTF_FontLineSkip = int function(const(TTF_Font)*);
	alias da_TTF_GetFontKerning = int function(const(TTF_Font)*);
	alias da_TTF_SetFontKerning = void function(TTF_Font*, int);
	alias da_TTF_FontFaces = int function(const(TTF_Font)*);
	alias da_TTF_FontFaceIsFixedWidth = int function(const(TTF_Font)*);
	alias da_TTF_FontFaceFamilyName = char* function(const(TTF_Font)*);
	alias da_TTF_FontFaceStyleName = char* function(const(TTF_Font)*);
	alias da_TTF_GlyphIsProvided = int function(const(TTF_Font)*, Uint16);
	alias da_TTF_GlyphMetrics = int function(TTF_Font*, Uint16, int*, int*, int*, int*, int*);
	alias da_TTF_SizeText = int function(TTF_Font*, const(char)*, int*, int*);
	alias da_TTF_SizeUTF8 = int function(TTF_Font*, const(char)*, int*, int*);
	alias da_TTF_SizeUNICODE = int function(TTF_Font*, Uint16*, int*, int*);
	alias da_TTF_RenderText_Solid = SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color);
	alias da_TTF_RenderUTF8_Solid = SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color);
	alias da_TTF_RenderUNICODE_Solid = SDL_Surface* function(TTF_Font*, const(Uint16)*, SDL_Color);
	alias da_TTF_RenderGlyph_Solid = SDL_Surface* function(TTF_Font*, Uint16, SDL_Color);
	alias da_TTF_RenderText_Shaded = SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color, SDL_Color);
	alias da_TTF_RenderUTF8_Shaded = SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color, SDL_Color);
	alias da_TTF_RenderUNICODE_Shaded = SDL_Surface* function(TTF_Font*, const(Uint16)*, SDL_Color, SDL_Color);
	alias da_TTF_RenderGlyph_Shaded = SDL_Surface* function(TTF_Font*, Uint16, SDL_Color, SDL_Color);
	alias da_TTF_RenderText_Blended = SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color);
	alias da_TTF_RenderUTF8_Blended = SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color);
	alias da_TTF_RenderUNICODE_Blended = SDL_Surface* function(TTF_Font*, const(Uint16)*, SDL_Color);
	alias da_TTF_RenderText_Blended_Wrapped = SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color, Uint32);
	alias da_TTF_RenderUTF8_Blended_Wrapped = SDL_Surface* function(TTF_Font*, const(char)*, SDL_Color, Uint32);
	alias da_TTF_RenderUNICODE_Blended_Wrapped = SDL_Surface* function(TTF_Font*, const(Uint16)*, SDL_Color, Uint32);
	alias da_TTF_RenderGlyph_Blended = SDL_Surface* function(TTF_Font*, Uint16, SDL_Color);
	alias da_TTF_CloseFont = void function(TTF_Font*);
	alias da_TTF_Quit = void function();
	alias da_TTF_WasInit = int function();
	alias da_TTF_GetFontKerningSize = int function(TTF_Font*, int, int);
}
__gshared 
{
	da_TTF_Linked_Version TTF_Linked_Version;
	da_TTF_ByteSwappedUNICODE TTF_ByteSwappedUNICODE;
	da_TTF_Init TTF_Init;
	da_TTF_OpenFont TTF_OpenFont;
	da_TTF_OpenFontIndex TTF_OpenFontIndex;
	da_TTF_OpenFontRW TTF_OpenFontRW;
	da_TTF_OpenFontIndexRW TTF_OpenFontIndexRW;
	da_TTF_GetFontStyle TTF_GetFontStyle;
	da_TTF_SetFontStyle TTF_SetFontStyle;
	da_TTF_GetFontOutline TTF_GetFontOutline;
	da_TTF_SetFontOutline TTF_SetFontOutline;
	da_TTF_GetFontHinting TTF_GetFontHinting;
	da_TTF_SetFontHinting TTF_SetFontHinting;
	da_TTF_FontHeight TTF_FontHeight;
	da_TTF_FontAscent TTF_FontAscent;
	da_TTF_FontDescent TTF_FontDescent;
	da_TTF_FontLineSkip TTF_FontLineSkip;
	da_TTF_GetFontKerning TTF_GetFontKerning;
	da_TTF_SetFontKerning TTF_SetFontKerning;
	da_TTF_FontFaces TTF_FontFaces;
	da_TTF_FontFaceIsFixedWidth TTF_FontFaceIsFixedWidth;
	da_TTF_FontFaceFamilyName TTF_FontFaceFamilyName;
	da_TTF_FontFaceStyleName TTF_FontFaceStyleName;
	da_TTF_GlyphIsProvided TTF_GlyphIsProvided;
	da_TTF_GlyphMetrics TTF_GlyphMetrics;
	da_TTF_SizeText TTF_SizeText;
	da_TTF_SizeUTF8 TTF_SizeUTF8;
	da_TTF_SizeUNICODE TTF_SizeUNICODE;
	da_TTF_RenderText_Solid TTF_RenderText_Solid;
	da_TTF_RenderUTF8_Solid TTF_RenderUTF8_Solid;
	da_TTF_RenderUNICODE_Solid TTF_RenderUNICODE_Solid;
	da_TTF_RenderGlyph_Solid TTF_RenderGlyph_Solid;
	da_TTF_RenderText_Shaded TTF_RenderText_Shaded;
	da_TTF_RenderUTF8_Shaded TTF_RenderUTF8_Shaded;
	da_TTF_RenderUNICODE_Shaded TTF_RenderUNICODE_Shaded;
	da_TTF_RenderGlyph_Shaded TTF_RenderGlyph_Shaded;
	da_TTF_RenderText_Blended TTF_RenderText_Blended;
	da_TTF_RenderUTF8_Blended TTF_RenderUTF8_Blended;
	da_TTF_RenderUNICODE_Blended TTF_RenderUNICODE_Blended;
	da_TTF_RenderText_Blended_Wrapped TTF_RenderText_Blended_Wrapped;
	da_TTF_RenderUTF8_Blended_Wrapped TTF_RenderUTF8_Blended_Wrapped;
	da_TTF_RenderUNICODE_Blended_Wrapped TTF_RenderUNICODE_Blended_Wrapped;
	da_TTF_RenderGlyph_Blended TTF_RenderGlyph_Blended;
	da_TTF_CloseFont TTF_CloseFont;
	da_TTF_Quit TTF_Quit;
	da_TTF_WasInit TTF_WasInit;
	da_TTF_GetFontKerningSize TTF_GetFontKerningSize;
}
alias TTF_RenderText = TTF_RenderText_Shaded;
alias TTF_RenderUTF8 = TTF_RenderUTF8_Shaded;
alias TTF_RenderUNICODE = TTF_RenderUNICODE_Shaded;
class DerelictSDL2ttfLoader : SharedLibLoader
{
	public this();
	protected override void loadSymbols();
}
__gshared DerelictSDL2ttfLoader DerelictSDL2ttf;
shared static this();
